##CH6.Tab3.ConfigFI.2by3.r

library(lavaan)
dat<-read.table(file = "grade7and8.long.823.dat", 
                col.names = c("PAT1P1","PAT1P2","PAT1P3","NAT1P1","NAT1P2","NAT1P3",
                              "PAT2P1","PAT2P2","PAT2P3","NAT2P1","NAT2P2","NAT2P3",
                              "PAT3P1","PAT3P2","PAT3P3","NAT3P1","NAT3P2","NAT3P3",
                             "grade", "female","black", "hispanic","other"))


##Make model##

mod1 <-'Pos1 =~ L1*PAT1P1 + L2*PAT1P2 + L3*PAT1P3
Neg1 =~ L4*NAT1P1 + L5*NAT1P2 + L6*NAT1P3
Pos2 =~ L7*PAT2P1 + L8*PAT2P2 + L9*PAT2P3
Neg2 =~ L10*NAT2P1 + L11*NAT2P2 + L12*NAT2P3
Pos3 =~ L13*PAT3P1 + L14*PAT3P2 + L15*PAT3P3
Neg3 =~ L16*NAT3P1 + L17*NAT3P2 + L18*NAT3P3
L1 == 3 - L2 - L3
L4 == 3 - L5 - L6
L7 == 3 - L8 - L9
L10== 3 - L11- L12
L13== 3 - L14- L15
L16== 3 - L17- L18

PAT1P1~~PAT1P1
PAT1P2~~PAT1P2
PAT1P3~~PAT1P3
NAT1P1~~NAT1P1
NAT1P2~~NAT1P2
NAT1P3~~NAT1P3
PAT2P1~~PAT2P1
PAT2P2~~PAT2P2
PAT2P3~~PAT2P3
NAT2P1~~NAT2P1
NAT2P2~~NAT2P2
NAT2P3~~NAT2P3
PAT3P1~~PAT3P1
PAT3P2~~PAT3P2
PAT3P3~~PAT3P3
NAT3P1~~NAT3P1
NAT3P2~~NAT3P2
NAT3P3~~NAT3P3

Pos1~~Pos1
Neg1~~Neg1
Pos2~~Pos2
Neg2~~Neg2
Pos3~~Pos3
Neg3~~Neg3

PAT1P1~~PAT2P1 + PAT3P1
PAT2P1~~PAT3P1
PAT1P2~~PAT2P2 + PAT3P2
PAT2P2~~PAT3P2
PAT1P3~~PAT2P3 + PAT3P3
PAT2P3~~PAT3P3
NAT1P1~~NAT2P1 + NAT3P1
NAT2P1~~NAT3P1
NAT1P2~~NAT2P2 + NAT3P2
NAT2P2~~NAT3P2
NAT1P3~~NAT2P3 + NAT3P3
NAT2P3~~NAT3P3

Pos1~~Pos2 + Pos3 + Neg1 + Neg2 + Neg3
Pos2~~Pos3 + Neg1 + Neg2 + Neg3
Pos3~~Neg1 + Neg2 + Neg3
Neg1~~Neg2 + Neg3
Neg2~~Neg3

Pos1~NA*1
Neg1~NA*1
Pos2~NA*1
Neg2~NA*1
Pos3~NA*1
Neg3~NA*1

PAT1P1~t1*1
PAT1P2~t2*1
PAT1P3~t3*1
NAT1P1~t4*1
NAT1P2~t5*1
NAT1P3~t6*1
PAT2P1~t7*1
PAT2P2~t8*1
PAT2P3~t9*1
NAT2P1~t10*1
NAT2P2~t11*1
NAT2P3~t12*1
PAT3P1~t13*1
PAT3P2~t14*1
PAT3P3~t15*1
NAT3P1~t16*1
NAT3P2~t17*1
NAT3P3~t18*1

t1 == 0 - t2 - t3
t4 == 0 - t5 - t6
t7 == 0 - t8 - t9
t10== 0 - t11- t12
t13== 0 - t14- t15
t16== 0 - t17- t18'

fit1 <- lavaan(mod1, data = dat, meanstructure=T)

summary(fit1, standardized=T, fit.measures=T)