##CH6.Tab3.InitialSEM.r  
##Set up##
library(lavaan)

dat <- read.table(file = "grade7and8.long.823.dat", 
                  col.names = c("PAT1P1","PAT1P2","PAT1P3","NAT1P1","NAT1P2","NAT1P3",
                                "PAT2P1","PAT2P2","PAT2P3","NAT2P1","NAT2P2","NAT2P3",
                                "PAT3P1","PAT3P2","PAT3P3","NAT3P1","NAT3P2","NAT3P3",
                                "grade", "female","black", "hispanic","other"))
##Make model## 
##Loadings
SEMmod <-'
Pos1 =~ L1*PAT1P1 + L2*PAT1P2 + L3*PAT1P3
Neg1 =~ L4*NAT1P1 + L5*NAT1P2 + L6*NAT1P3
Pos2 =~ L1*PAT2P1 + L2*PAT2P2 + L3*PAT2P3
Neg2 =~ L4*NAT2P1 + L5*NAT2P2 + L6*NAT2P3
Pos3 =~ L1*PAT3P1 + L2*PAT3P2 + L3*PAT3P3
Neg3 =~ L4*NAT3P1 + L5*NAT3P2 + L6*NAT3P3

## Latent factor variance and covariance (Psi matrix)
Pos1 ~~ Pos1 ##Psi 1,1
Pos1 ~~ Neg1 ##Psi 1,2
Neg1 ~~ Neg1 ##Psi 2,2

Pos2 ~~ Pos2 ##Psi 3,3
Pos2 ~~ Neg2 ##Psi 3,4
Neg2 ~~ Neg2 ##Psi 4,4

Pos3 ~~ Pos3  ##Psi 5,5
Pos3 ~~ Neg3  ##Psi 5,6
Neg3 ~~ Neg3  ##Psi 6,6

## Latent means (Alpha matrix)  
Pos1 ~ 1
Neg1 ~ 1
Pos2 ~ 1
Neg2 ~ 1
Pos3 ~ 1
Neg3 ~ 1

## indicator resduals var-covar (Theta-Epsilon matrix)
## Time1 
PAT1P1 ~~ PAT1P1
PAT1P1 ~~ PAT2P1
PAT1P1 ~~ PAT3P1

PAT1P2 ~~ PAT1P2
PAT1P2 ~~ PAT2P2
PAT1P2 ~~ PAT3P2

PAT1P3 ~~ PAT1P3
PAT1P3 ~~ PAT2P3
PAT1P3 ~~ PAT3P3

NAT1P1 ~~ NAT1P1
NAT1P1 ~~ NAT2P1
NAT1P1 ~~ NAT3P1

NAT1P2 ~~ NAT1P2
NAT1P2 ~~ NAT2P2
NAT1P2 ~~ NAT3P2

NAT1P3 ~~ NAT1P3
NAT1P3 ~~ NAT2P3
NAT1P3 ~~ NAT3P3

#Time2  
PAT2P1 ~~ PAT2P1
PAT2P1 ~~ PAT3P1

PAT2P2 ~~ PAT2P2
PAT2P2 ~~ PAT3P2

PAT2P3 ~~ PAT2P3
PAT2P3 ~~ PAT3P3

NAT2P1 ~~ NAT2P1
NAT2P1 ~~ NAT3P1

NAT2P2 ~~ NAT2P2
NAT2P2 ~~ NAT3P2

NAT2P3 ~~ NAT2P3
NAT2P3 ~~ NAT3P3

## Time3  
PAT3P1  ~~ PAT3P1
PAT3P2 ~~ PAT3P2 
PAT3P3 ~~ PAT3P3
NAT3P1 ~~ NAT3P1
NAT3P2 ~~ NAT3P2
NAT3P3 ~~ NAT3P3

##Indicator means/intercepts (Tau vector)
PAT1P1 ~ t1*1
PAT1P2 ~ t2*1
PAT1P3 ~ t3*1
NAT1P1 ~ t4*1
NAT1P2 ~ t5*1
NAT1P3 ~ t6*1

PAT2P1 ~ t1*1
PAT2P2 ~ t2*1
PAT2P3 ~ t3*1
NAT2P1 ~ t4*1
NAT2P2 ~ t5*1
NAT2P3 ~ t6*1

PAT3P1 ~ t1*1
PAT3P2 ~ t2*1
PAT3P3 ~ t3*1
NAT3P1 ~ t4*1
NAT3P2 ~ t5*1
NAT3P3 ~ t6*1


##Regression paths here
Pos2 ~ Pos1
Pos3 ~ Pos1 + Pos2
Neg2 ~ Neg1 
Neg3 ~ Neg1 + Neg2


## Constraints 
L1 == 3 - L2 - L3
L4 == 3 - L5 - L6
t1 == 0 - t2 - t3
t4 == 0 - t5 - t6'
   
fitSEM <- lavaan(SEMmod, data = dat, meanstructure =  TRUE)
  
summary(fitSEM, standardized = TRUE, fit.measures = TRUE)