##CH6.Tab3.Means.v.Str.2by3.r

library(lavaan)

##Set up##
dat <- read.table(file = "grade7and8.long.823.dat", 
                col.names = c("PAT1P1","PAT1P2","PAT1P3","NAT1P1","NAT1P2","NAT1P3",
                              "PAT2P1","PAT2P2","PAT2P3","NAT2P1","NAT2P2","NAT2P3",
                              "PAT3P1","PAT3P2","PAT3P3","NAT3P1","NAT3P2","NAT3P3",
                             "grade", "female","black", "hispanic","other"))

##look at your data
#head(dat)


##Make model##
mod1 <-'
	### loadings
	Pos1 =~ L1*PAT1P1 + L2*PAT1P2 + L3*PAT1P3
	Neg1 =~ L4*NAT1P1 + L5*NAT1P2 + L6*NAT1P3
	Pos2 =~ L1*PAT2P1 + L2*PAT2P2 + L3*PAT2P3
	Neg2 =~ L4*NAT2P1 + L5*NAT2P2 + L6*NAT2P3
	Pos3 =~ L1*PAT3P1 + L2*PAT3P2 + L3*PAT3P3
	Neg3 =~ L4*NAT3P1 + L5*NAT3P2 + L6*NAT3P3
	L1 == 3 - L2 - L3
	L4 == 3 - L5 - L6


	### factor variance
	Pos1 ~~ Pos1
	Neg1 ~~ Neg1
	Pos2 ~~ Pos2
	Neg2 ~~ Neg2
	Pos3 ~~ Pos3
	Neg3 ~~ Neg3

	### factor covariance
	Pos1 ~~ Pos2 + Pos3 + Neg1 + Neg2 + Neg3
	Pos2 ~~ Pos3 + Neg1 + Neg2 + Neg3
	Pos3 ~~ Neg1 + Neg2 + Neg3
	Neg1 ~~ Neg2 + Neg3
	Neg2 ~~ Neg3

	### residual variance
	PAT1P1 ~~ PAT1P1
	PAT1P2 ~~ PAT1P2
	PAT1P3 ~~ PAT1P3
	NAT1P1 ~~ NAT1P1
	NAT1P2 ~~ NAT1P2
	NAT1P3 ~~ NAT1P3
	PAT2P1 ~~ PAT2P1
	PAT2P2 ~~ PAT2P2
	PAT2P3 ~~ PAT2P3
	NAT2P1 ~~ NAT2P1
	NAT2P2 ~~ NAT2P2
	NAT2P3 ~~ NAT2P3
	PAT3P1 ~~ PAT3P1
	PAT3P2 ~~ PAT3P2
	PAT3P3 ~~ PAT3P3
	NAT3P1 ~~ NAT3P1
	NAT3P2 ~~ NAT3P2
	NAT3P3 ~~ NAT3P3

	### cross-time correlated residuals
	PAT1P1 ~~ PAT2P1 + PAT3P1
	PAT2P1 ~~ PAT3P1
	PAT1P2 ~~ PAT2P2 + PAT3P2
	PAT2P2 ~~ PAT3P2
	PAT1P3 ~~ PAT2P3 + PAT3P3
	PAT2P3 ~~ PAT3P3
	NAT1P1 ~~ NAT2P1 + NAT3P1
	NAT2P1 ~~ NAT3P1
	NAT1P2 ~~ NAT2P2 + NAT3P2
	NAT2P2 ~~ NAT3P2
	NAT1P3 ~~ NAT2P3 + NAT3P3
	NAT2P3 ~~ NAT3P3

	## latent mean
	#######################################################
	#### label "A1" and "A2" add equality of means across time ####
	#######################################################
	Pos1 ~ A1*1
	Neg1 ~ A2*1
	Pos2 ~ A1*1
	Neg2 ~ A2*1
	Pos3 ~ A1*1
	Neg3 ~ A2*1

	## intercept
	PAT1P1 ~ t1*1
	PAT1P2 ~ t2*1
	PAT1P3 ~ t3*1
	NAT1P1 ~ t4*1
	NAT1P2 ~ t5*1
	NAT1P3 ~ t6*1
	PAT2P1 ~ t1*1
	PAT2P2 ~ t2*1
	PAT2P3 ~ t3*1
	NAT2P1 ~ t4*1
	NAT2P2 ~ t5*1
	NAT2P3 ~ t6*1
	PAT3P1 ~ t1*1
	PAT3P2 ~ t2*1
	PAT3P3 ~ t3*1
	NAT3P1 ~ t4*1
	NAT3P2 ~ t5*1
	NAT3P3 ~ t6*1

	t1 == 0 - t2 - t3
	t4 == 0 - t5 - t6
	'

fit1 <- lavaan(mod1, data = dat, meanstructure=T)
#### Did not converge on first run, used final estimates on starting values for next run
fit2 <- lavaan(mod1, data = dat, meanstructure=T, start=fit1)
summary(fit2, standardized=T, fit.measures=T)