##CH6.Tab3.Weak.2by3.r

library(lavaan)

##Set up##
dat <- read.table(file = "grade7and8.long.823.dat", 
                  col.names = c("PAT1P1","PAT1P2","PAT1P3","NAT1P1","NAT1P2","NAT1P3",
                                "PAT2P1","PAT2P2","PAT2P3","NAT2P1","NAT2P2","NAT2P3",
                                "PAT3P1","PAT3P2","PAT3P3","NAT3P1","NAT3P2","NAT3P3",
                                "grade", "female","black", "hispanic","other"))



modWK <-'
Pos1 =~ L1*PAT1P1 + L2*PAT1P2 + L3*PAT1P3
Neg1 =~ L4*NAT1P1 + L5*NAT1P2 + L6*NAT1P3
Pos2 =~ L1*PAT2P1 + L2*PAT2P2 + L3*PAT2P3
Neg2 =~ L4*NAT2P1 + L5*NAT2P2 + L6*NAT2P3
Pos3 =~ L1*PAT3P1 + L2*PAT3P2 + L3*PAT3P3
Neg3 =~ L4*NAT3P1 + L5*NAT3P2 + L6*NAT3P3

## indicator residual variances (Theta-Epsilon matrix)
PAT1P1 ~~ PAT1P1
PAT1P2 ~~ PAT1P2
PAT1P3 ~~ PAT1P3
NAT1P1 ~~ NAT1P1
NAT1P2 ~~ NAT1P2
NAT1P3 ~~ NAT1P3
PAT2P1 ~~ PAT2P1
PAT2P2 ~~ PAT2P2
PAT2P3 ~~ PAT2P3
NAT2P1 ~~ NAT2P1
NAT2P2 ~~ NAT2P2
NAT2P3 ~~ NAT2P3
PAT3P1 ~~ PAT3P1
PAT3P2 ~~ PAT3P2
PAT3P3 ~~ PAT3P3
NAT3P1 ~~ NAT3P1
NAT3P2 ~~ NAT3P2
NAT3P3 ~~ NAT3P3

### cross-time correlated residuals 
## correlate residuals of indicators with themselves across time
PAT1P1 ~~ PAT2P1 + PAT3P1
PAT2P1 ~~ PAT3P1
PAT1P2 ~~ PAT2P2 + PAT3P2
PAT2P2 ~~ PAT3P2
PAT1P3 ~~ PAT2P3 + PAT3P3
PAT2P3 ~~ PAT3P3
NAT1P1 ~~ NAT2P1 + NAT3P1
NAT2P1 ~~ NAT3P1
NAT1P2 ~~ NAT2P2 + NAT3P2
NAT2P2 ~~ NAT3P2
NAT1P3 ~~ NAT2P3 + NAT3P3
NAT2P3 ~~ NAT3P3

## indicator intercepts (Tau vector), include labels for model constraints
PAT1P1 ~ t1*1
PAT1P2 ~ t2*1
PAT1P3 ~ t3*1
NAT1P1 ~ t4*1
NAT1P2 ~ t5*1
NAT1P3 ~ t6*1

PAT2P1 ~ t7*1
PAT2P2 ~ t8*1
PAT2P3 ~ t9*1
NAT2P1 ~ t10*1
NAT2P2 ~ t11*1
NAT2P3 ~ t12*1

PAT3P1 ~ t13*1
PAT3P2 ~ t14*1
PAT3P3 ~ t15*1
NAT3P1 ~ t16*1
NAT3P2 ~ t17*1
NAT3P3 ~ t18*1

### latent factor variance (Psi matrix)
	Pos1 ~~ Pos1
	Neg1 ~~ Neg1
	Pos2 ~~ Pos2
	Neg2 ~~ Neg2
	Pos3 ~~ Pos3
	Neg3 ~~ Neg3

### factor covariance
	Pos1 ~~ Pos2 + Pos3 + Neg1 + Neg2 + Neg3
	Pos2 ~~ Pos3 + Neg1 + Neg2 + Neg3
	Pos3 ~~ Neg1 + Neg2 + Neg3
	Neg1 ~~ Neg2 + Neg3
	Neg2 ~~ Neg3

## latent means (Alpha matrix)
Pos1 ~ 1
Neg1 ~ 1
Pos2 ~ 1
Neg2 ~ 1
Pos3 ~ 1
Neg3 ~ 1

## model constraints
L1 == 3 - L2 - L3
L4 == 3 - L5 - L6
t1 == 0 - t2 - t3
t4 == 0 - t5 - t6
t7 == 0 - t8 - t9
t10 == 0 - t11 - t12
t13 == 0 - t14 - t15
t16 == 0 - t17 - t18
'

# names(dat)
# lavaanNames(lavaanify(modWK))

fit1 <- lavaan(modWK, data = dat, meanstructure=TRUE)
#### Did not converge on first run, used final estimates on starting values for next run
fit2 <- lavaan(modWK, data = dat, meanstructure=TRUE, start = fit1)
summary(fit2, standardized=TRUE, fit.measures=TRUE)

# P <- 18*(21)/ 2
# x <- 10 + 18 + 15 + 18 + 18
# DF <- 189 - 79
# DF
